/////////////////////////////////////////////////////////////////////////
///@system Ź̨ϵͳ
///@company ϺڻϢ޹˾
///@file USTPFtdcTraderApi.h
///@brief ˿ͻ˽ӿ
///@history
/////////////////////////////////////////////////////////////////////////

#ifndef __CFFEX_FEMAS_FTDC_TRADER_API_H__
#define __CFFEX_FEMAS_FTDC_TRADER_API_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "USTPFtdcUserApiStruct.h"

#if defined(ISLIB) && defined(WIN32)
#ifdef LIB_TRADER_API_EXPORT
#define TRADER_API_EXPORT __declspec(dllexport)
#else
#define TRADER_API_EXPORT __declspec(dllimport)
#endif
#else
#define TRADER_API_EXPORT 
#endif

class CUstpFtdcTraderSpi
{
public:
	///ͻ뽻׺̨ͨʱδ¼ǰ÷á
	virtual void OnFrontConnected(){};
	virtual void OnQryFrontConnected(){};	
	///ͻ뽻׺̨ͨӶϿʱ÷áAPIԶӣͻ˿ɲ
	///@param nReason ԭ
	///        0x1001 ʧ
	///        0x1002 дʧ
	///        0x2001 ʱ
	///        0x2002 ʧ
	///        0x2003 յ
	virtual void OnFrontDisconnected(int nReason){};
	virtual void OnQryFrontDisconnected(int nReason){};
	
	///ʱ档ʱδյʱ÷á
	///@param nTimeLapse ϴνձĵʱ
	virtual void OnHeartBeatWarning(int nTimeLapse){};
	
	///Ļصʼ֪ͨAPIյһĺȵñȻǸĻصǱĻص֪ͨ
	///@param nTopicID 루˽ȣ
	///@param nSequenceNo 
	virtual void OnPackageStart(int nTopicID, int nSequenceNo){};
	
	///Ļص֪ͨAPIյһĺȵñĻصʼ֪ͨȻǸĻصñ
	///@param nTopicID 루˽ȣ
	///@param nSequenceNo 
	virtual void OnPackageEnd(int nTopicID, int nSequenceNo){};


	///Ӧ
	virtual void OnRspError(CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ǰϵͳû¼Ӧ
	virtual void OnRspUserLogin(CUstpFtdcRspUserLoginField *pRspUserLogin, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///û˳Ӧ
	virtual void OnRspUserLogout(CUstpFtdcRspUserLogoutField *pRspUserLogout, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///û޸Ӧ
	virtual void OnRspUserPasswordUpdate(CUstpFtdcUserPasswordUpdateField *pUserPasswordUpdate, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///˵ȷӦ
	virtual void OnRspSettlementInfoConfirm(CUstpFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ϢȷӦ
	virtual void OnRspMsgNotifyConfirm(CUstpFtdcMsgNotifyConfirmField *pMsgNotifyConfirm, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///¼Ӧ
	virtual void OnRspOrderInsert(CUstpFtdcInputOrderField *pInputOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ӧ
	virtual void OnRspOrderAction(CUstpFtdcOrderActionField *pOrderAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///¼Ӧ
	virtual void OnRspQuoteInsert(CUstpFtdcInputQuoteField *pInputQuote, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///۲Ӧ
	virtual void OnRspQuoteAction(CUstpFtdcQuoteActionField *pQuoteAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯӦ
	virtual void OnRspForQuote(CUstpFtdcReqForQuoteField *pReqForQuote, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ͻӦ
	virtual void OnRspMarginCombAction(CUstpFtdcInputMarginCombActionField *pInputMarginCombAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///֪ͨ
	virtual void OnRtnFlowMessageCancel(CUstpFtdcFlowMessageCancelField *pFlowMessageCancel) {};

	///ɽر
	virtual void OnRtnTrade(CUstpFtdcTradeField *pTrade) {};

	///ر
	virtual void OnRtnOrder(CUstpFtdcOrderField *pOrder) {};

	///¼ر
	virtual void OnErrRtnOrderInsert(CUstpFtdcInputOrderField *pInputOrder, CUstpFtdcRspInfoField *pRspInfo) {};

	///ر
	virtual void OnErrRtnOrderAction(CUstpFtdcOrderActionField *pOrderAction, CUstpFtdcRspInfoField *pRspInfo) {};

	///˻ر
	virtual void OnRtnInvestorAccountDeposit(CUstpFtdcInvestorAccountDepositResField *pInvestorAccountDepositRes) {};

	///ۻر
	virtual void OnRtnQuote(CUstpFtdcRtnQuoteField *pRtnQuote) {};

	///¼ر
	virtual void OnErrRtnQuoteInsert(CUstpFtdcInputQuoteField *pInputQuote, CUstpFtdcRspInfoField *pRspInfo) {};

	///۳ر
	virtual void OnErrRtnQuoteAction(CUstpFtdcQuoteActionField *pQuoteAction, CUstpFtdcRspInfoField *pRspInfo) {};

	///ѯۻر
	virtual void OnRtnForQuote(CUstpFtdcReqForQuoteField *pReqForQuote) {};

	///ͻȷ
	virtual void OnRtnMarginCombAction(CUstpFtdcInputMarginCombActionField *pInputMarginCombAction) {};

	///ѯǰϵͳû¼Ӧ
	virtual void OnRspQueryUserLogin(CUstpFtdcRspUserLoginField *pRspUserLogin, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯӦ
	virtual void OnRspQryOrder(CUstpFtdcOrderField *pOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ɽѯӦ
	virtual void OnRspQryTrade(CUstpFtdcTradeField *pTrade, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ͷ˻ѯӦ
	virtual void OnRspQryUserInvestor(CUstpFtdcRspUserInvestorField *pRspUserInvestor, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ױѯӦ
	virtual void OnRspQryTradingCode(CUstpFtdcRspTradingCodeField *pRspTradingCode, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ͷʽ˻ѯӦ
	virtual void OnRspQryInvestorAccount(CUstpFtdcRspInvestorAccountField *pRspInvestorAccount, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ԼѯӦ
	virtual void OnRspQryInstrument(CUstpFtdcRspInstrumentField *pRspInstrument, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯӦ
	virtual void OnRspQryExchange(CUstpFtdcRspExchangeField *pRspExchange, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ͷֲֲ߳ѯӦ
	virtual void OnRspQryInvestorPosition(CUstpFtdcRspInvestorPositionField *pRspInvestorPosition, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ϹѯӦ
	virtual void OnRspQryComplianceParam(CUstpFtdcRspComplianceParamField *pRspComplianceParam, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ͶʲѯӦ
	virtual void OnRspQryInvestorFee(CUstpFtdcInvestorFeeField *pInvestorFee, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ͷ֤߱ʲѯӦ
	virtual void OnRspQryInvestorMargin(CUstpFtdcInvestorMarginField *pInvestorMargin, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ױϳֲֲѯӦ
	virtual void OnRspQryInvestorCombPosition(CUstpFtdcRspInvestorCombPositionField *pRspInvestorCombPosition, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ԼϢѯӦ
	virtual void OnRspQryInstrumentGroup(CUstpFtdcRspInstrumentGroupField *pRspInstrumentGroup, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ϱ֤ͲѯӦ
	virtual void OnRspQryClientMarginCombType(CUstpFtdcRspClientMarginCombTypeField *pRspClientMarginCombType, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ȩ¼Ӧ
	virtual void OnRspExecOrderInsert(CUstpFtdcInputExecOrderField *pInputExecOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ȨӦ
	virtual void OnRspExecOrderAction(CUstpFtdcInputExecOrderActionField *pInputExecOrderAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ȩ֪ͨ
	virtual void OnRtnExecOrder(CUstpFtdcExecOrderField *pExecOrder) {};

	///Ȩ¼ر
	virtual void OnErrRtnExecOrderInsert(CUstpFtdcInputExecOrderField *pInputExecOrder, CUstpFtdcRspInfoField *pRspInfo) {};

	///Ȩر
	virtual void OnErrRtnExecOrderAction(CUstpFtdcInputExecOrderActionField *pInputExecOrderAction, CUstpFtdcRspInfoField *pRspInfo) {};

	///ѯ˵ȷӦ
	virtual void OnRspQrySettlementInfoConfirm(CUstpFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯӦ
	virtual void OnRspQryOrderFailed(CUstpFtdcOrderInsertFailedField *pOrderInsertFailed, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯֲϸӦ
	virtual void OnRspQryInvestorPositionDetail(CUstpFtdcRspQryInvestorPositionDetailField *pRspQryInvestorPositionDetail, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯϳֲϸӦ
	virtual void OnRspQryInvestorPositionCombDetail(CUstpFtdcRspQryInvestorPositionCombDetailField *pRspQryInvestorPositionCombDetail, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ϵͳʱѯӦ
	virtual void OnRspQrySystemTime(CUstpFtdcRspQrySystemTimeField *pRspQrySystemTime, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯ֤ŻݲӦ
	virtual void OnRspQryMarginPrefParam(CUstpFtdcRspQryMarginPrefParamField *pRspQryMarginPrefParam, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///͸ܿͻ֤Ӧ
	virtual void OnRspDSUserCertification(CUstpFtdcDSUserCertRspDataField *pDSUserCertRspData, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///͸ϢɼмϴϢӦ
	virtual void OnRspDSProxySubmitInfo(CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯͶ߽Ӧ
	virtual void OnRspQuerySettlementInfo(CUstpFtdcSettlementRspField *pSettlementRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ʽ˻Ӧ
	virtual void OnRspTradingAccountPasswordUpdate(CUstpFtdcTradingAccountPasswordUpdateRspField *pTradingAccountPasswordUpdateRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯתˮӦ
	virtual void OnRspQueryTransferSeriaOffset(CUstpFtdcTransferSerialFieldRspField *pTransferSerialFieldRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯǩԼϵӦ
	virtual void OnRspQueryAccountRegister(CUstpFtdcAccountregisterRspField *pAccountregisterRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ڻʽתڻӦ
	virtual void OnRspFromBankToFutureByFuture(CUstpFtdcTransferFieldReqField *pTransferFieldReq, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ڻʽתڻ֪ͨ
	virtual void OnRtnFromBankToFutureByFuture(CUstpFtdcTransferFieldReqField *pTransferFieldReq) {};

	///ڻڻʽתӦ
	virtual void OnRspFromFutureToBankByFuture(CUstpFtdcTransferFieldReqField *pTransferFieldReq, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ڻڻʽת֪ͨ
	virtual void OnRtnFromFutureToBankByFuture(CUstpFtdcTransferFieldReqField *pTransferFieldReq) {};

	///зڻʽת֪ͨ
	virtual void OnRtnFromFutureToBankByBank(CUstpFtdcTransferFieldReqField *pTransferFieldReq) {};

	///зʽתڻ֪ͨ
	virtual void OnRtnFromBankToFutureByBank(CUstpFtdcTransferFieldReqField *pTransferFieldReq) {};

	///ڻѯӦ
	virtual void OnRspQueryBankAccountMoneyByFuture(CUstpFtdcAccountFieldRspField *pAccountFieldRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ڻѯ֪ͨ
	virtual void OnRtnQueryBankBalanceByFuture(CUstpFtdcAccountFieldRtnField *pAccountFieldRtn) {};

	///зڿ֪ͨ
	virtual void OnRtnOpenAccountByBank(CUstpFtdcSignUpOrCancleAccountRspFieldField *pSignUpOrCancleAccountRspField) {};

	///з֪ͨ
	virtual void OnRtnCancelAccountByBank(CUstpFtdcSignUpOrCancleAccountRspFieldField *pSignUpOrCancleAccountRspField) {};

	///зʽתڻӦ
	virtual void OnRspFromBankToFutureByBank(CUstpFtdcTransferFieldReqField *pTransferFieldReq, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///зڻʽתӦ
	virtual void OnRspFromFutureToBankByBank(CUstpFtdcTransferFieldReqField *pTransferFieldReq, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///˴﷢ʽתڻ֪ͨ
	virtual void OnRtnFromBankToFutureByJSD(CUstpFtdcJSDMoneyField *pJSDMoney) {};

	///˴﷢ڻʽת֪ͨ
	virtual void OnRtnFromFutureToBankByJSD(CUstpFtdcJSDMoneyField *pJSDMoney) {};

	///תͶʽ˻䶯֪ͨ
	virtual void OnRtnTransferInvestorAccountChanged(CUstpFtdcTransferFieldReqField *pTransferFieldReq) {};

	///ڻ˻ǩԼӦ
	virtual void OnRspSignUpAccountByFuture(CUstpFtdcSignUpOrCancleAccountRspFieldField *pSignUpOrCancleAccountRspField, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ڻ˻ԼӦ
	virtual void OnRspCancleAccountByFuture(CUstpFtdcSignUpOrCancleAccountRspFieldField *pSignUpOrCancleAccountRspField, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯǩԼ״̬Ӧ
	virtual void OnRspQuerySignUpOrCancleAccountStatus(CUstpFtdcQuerySignUpOrCancleAccountStatusRspFieldField *pQuerySignUpOrCancleAccountStatusRspField, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ڻ˻Ӧ
	virtual void OnRspChangeAccountByFuture(CUstpFtdcChangeAccountRspFieldField *pChangeAccountRspField, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///תͶʽ˻䶯֪ͨ
	virtual void OnRtnTransferInvestorMoneyChanged(CUstpFtdcSyncMoneyTransferField *pSyncMoneyTransfer) {};

	///ѯ󱨵Ӧ
	virtual void OnRspQueryMaxOrderVolume(CUstpFtdcRspQueryMaxOrderVolumeField *pRspQueryMaxOrderVolume, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ڻѯǩԼӦ
	virtual void OnRspQueryContractBank(CUstpFtdcQryContractBankRspField *pQryContractBankRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///潻ʻӦ
	virtual void OnRspOpenSimTradeAccount(CUstpFtdcSimTradeAccountInfoField *pSimTradeAccountInfo, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///潻ʻѯӦ
	virtual void OnRspCheckOpenSimTradeAccount(CUstpFtdcSimTradeAccountInfoField *pSimTradeAccountInfo, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯ֤ϵͳ͹˾ʽ˻ԿӦ
	virtual void OnRspCFMMCTradingAccountKey(CUstpFtdcCFMMCTradingAccountKeyRspField *pCFMMCTradingAccountKeyRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ϣ֪ͨ
	virtual void OnRtnMsgNotify(CUstpFtdcMsgNotifyField *pMsgNotify) {};

	///ֱֲ仯֪ͨ
	virtual void OnRtnClientPositionChange(CUstpFtdcClientPositionChangeField *pClientPositionChange) {};

	///ʽ仯֪ͨ
	virtual void OnRtnInvestorAccountChange(CUstpFtdcInvestorAccountChangeField *pInvestorAccountChange) {};

	///ֱֲ仯֪ͨӦ
	virtual void OnRspQryEnableRtnMoneyPositoinChange(CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յӦ
	virtual void OnRspOrderInsertAccept(CUstpFtdcInputOrderField *pInputOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յӦ
	virtual void OnRspOrderActionAccept(CUstpFtdcOrderActionField *pOrderAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յӦ
	virtual void OnRspQuoteInsertAccept(CUstpFtdcInputQuoteField *pInputQuote, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յӦ
	virtual void OnRspQuoteActionAccept(CUstpFtdcQuoteActionField *pQuoteAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յѯӦ
	virtual void OnRspForQuoteAccept(CUstpFtdcReqForQuoteField *pReqForQuote, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յȨӦ
	virtual void OnRspExecOrderInsertAccept(CUstpFtdcInputExecOrderField *pInputExecOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յȨӦ
	virtual void OnRspExecOrderActionAccept(CUstpFtdcInputExecOrderActionField *pInputExecOrderAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ֲָӯ仯֪ͨ
	virtual void OnRtnClientPositionChangeMD(CUstpFtdcClientPositionProfitChangeField *pClientPositionProfitChange) {};

	///ʽ𸡶ӯ仯֪ͨ
	virtual void OnRtnInvestorAccountChangeMD(CUstpFtdcInvestorAccountProfitChangeField *pInvestorAccountProfitChange) {};

	///ʷѯӦ
	virtual void OnRspQueryHisOrder(CUstpFtdcOrderField *pOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ʷɽѯӦ
	virtual void OnRspQueryHisTrade(CUstpFtdcTradeField *pTrade, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѺӦ
	virtual void OnRspCurrencyPledge(CUstpFtdcCurrencyPledgeField *pCurrencyPledge, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯ۴ر
	virtual void OnErrRtnForQuote(CUstpFtdcReqForQuoteField *pReqForQuote, CUstpFtdcRspInfoField *pRspInfo) {};

	///ͻϲִر
	virtual void OnErrRtnMarginCombAction(CUstpFtdcInputMarginCombActionField *pInputMarginCombAction, CUstpFtdcRspInfoField *pRspInfo) {};

	///ȨԳ¼Ӧ
	virtual void OnRspExecSelfCloseInsert(CUstpFtdcExecSelfCloseField *pExecSelfClose, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ȨԳ¼Ӧ
	virtual void OnErrRtnExecSelfCloseInsert(CUstpFtdcExecSelfCloseField *pExecSelfClose, CUstpFtdcRspInfoField *pRspInfo) {};

	///ȨԳó¼Ӧ
	virtual void OnRspExecSelfCloseAction(CUstpFtdcExecSelfCloseActionField *pExecSelfCloseAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ȨԳ¼Ӧ
	virtual void OnErrRtnExecSelfCloseAction(CUstpFtdcExecSelfCloseActionField *pExecSelfCloseAction, CUstpFtdcRspInfoField *pRspInfo) {};

	///յȨԳ¼Ӧ
	virtual void OnRspExecSelfCloseInsertAccept(CUstpFtdcExecSelfCloseField *pExecSelfClose, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յȨԳ峷¼Ӧ
	virtual void OnRspExecSelfCloseActionAccept(CUstpFtdcExecSelfCloseActionField *pExecSelfCloseAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯֻ̼Ӧ
	virtual void OnRspQrySpotClosePrice(CUstpFtdcSportClosePriceField *pSportClosePrice, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ȩ׳ɱѯӦ
	virtual void OnRspQryOptionTradeCost(CUstpFtdcOptionTradeCostField *pOptionTradeCost, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ϲֲѯӦ
	virtual void OnRspQryCombAction(CUstpFtdcQryCombActionField *pQryCombAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ƷϢѯӦ
	virtual void OnRspQryProduct(CUstpFtdcProductField *pProduct, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ʒ״̬ͽӿ
	virtual void OnRtnProductStatus(CUstpFtdcProductStatusField *pProductStatus) {};

	///ȨԳ˽ͽӿ
	virtual void OnRtnExecSelfClose(CUstpFtdcExecSelfCloseField *pExecSelfClose) {};

	///ȨԳòѯӦ
	virtual void OnRspExecSelfClose(CUstpFtdcExecSelfCloseField *pExecSelfClose, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///볷Ӧ
	virtual void OnRspMarginCombCancel(CUstpFtdcAPIMarginCombCancelField *pAPIMarginCombCancel, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///յͻӦ
	virtual void OnRspMarginCombActionAccept(CUstpFtdcInputMarginCombActionField *pInputMarginCombAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///лӦ
	virtual void OnRspChangeCenter(CUstpFtdcRspChangeCenterField *pRspChangeCenter, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ĲѯӦ
	virtual void OnRspQryTradeCenter(CUstpFtdcRspTradeCenterField *pRspTradeCenter, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///볷Ӧ
	virtual void OnRspMarginCombCancelAccept(CUstpFtdcAPIInputMarginCombCancelField *pAPIInputMarginCombCancel, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///볷ر
	virtual void OnErrRtnMarginCombCancel(CUstpFtdcAPIMarginCombCancelField *pAPIMarginCombCancel, CUstpFtdcRspInfoField *pRspInfo) {};

	///Ԥ񵥱¼Ӧ
	virtual void OnRspParkedOrderInsert(CUstpFtdcParkedOrderInsertField *pParkedOrderInsert, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ԥ񵥳Ӧ
	virtual void OnRspParkedOrderAction(CUstpFtdcParkedOrderActionField *pParkedOrderAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ԥ񵥲ѯӦ
	virtual void OnRspQryParkedOrder(CUstpFtdcParkedOrderField *pParkedOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///¼Ӧ
	virtual void OnRspConditionalOrderInsert(CUstpFtdcConditionalOrderInsertField *pConditionalOrderInsert, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ӧ
	virtual void OnRspConditionalOrderAction(CUstpFtdcConditionalOrderActionField *pConditionalOrderAction, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ѯӦ
	virtual void OnRspQryConditionalOrder(CUstpFtdcConditionalOrderField *pConditionalOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ԥ񵥴رϢ
	virtual void OnRtnParkedOrder(CUstpFtdcParkedOrderField *pParkedOrder) {};

	///رϢ
	virtual void OnRtnConditionalOrder(CUstpFtdcConditionalOrderField *pConditionalOrder) {};

	///ѯʷתˮӦ
	virtual void OnRspQueryHisTransferSerial(CUstpFtdcHisTransferSerialFieldRspField *pHisTransferSerialFieldRsp, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///۲ѯӦ
	virtual void OnRspQryQuote(CUstpFtdcQuoteField *pQuote, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///ȨѯӦ
	virtual void OnRspQryExecOrder(CUstpFtdcExecOrderField *pExecOrder, CUstpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {};

	///Ԥ񵥴Ӧ
	virtual void OnErrRtnParkedOrderInsert(CUstpFtdcParkedOrderInsertField *pParkedOrderInsert, CUstpFtdcRspInfoField *pRspInfo) {};

	///Ӧ
	virtual void OnErrRtnConditionalOrderInsert(CUstpFtdcConditionalOrderInsertField *pConditionalOrderInsert, CUstpFtdcRspInfoField *pRspInfo) {};
};

class TRADER_API_EXPORT CUstpFtdcTraderApi
{
public:
	///TraderApi
	///@param pszFlowPath ϢļĿ¼ĬΪǰĿ¼
	///@return UserApi
	static CUstpFtdcTraderApi *CreateFtdcTraderApi(const char *pszFlowPath = "");
	
	///ȡϵͳ汾
	///@param nMajorVersion 汾
	///@param nMinorVersion Ӱ汾
	///@return ϵͳʶַ
	static const char *GetVersion(int &nMajorVersion, int &nMinorVersion);
	
	///ɾӿڶ
	///@remark ʹñӿڶʱ,øúɾӿڶ
	virtual void Release() = 0;
	
	///ʼ
	///@remark ʼл,ֻеú,ӿڲſʼ
	virtual void Init() = 0;
	
	///ȴӿ߳̽
	///@return ߳˳
	virtual int Join() = 0;
	
	///ȡǰ
	///@retrun ȡĽ
	///@remark ֻе¼ɹ,ܵõȷĽ
	virtual const char *GetTradingDay() = 0;
	
	///עǰûַ
	///@param pszFrontAddressǰûַ
	///@remark ַĸʽΪprotocol://ipaddress:port磺IPV4: tcp://127.0.0.1:17001  IPV6: tcp://2001:250:250:250:250:250:250:222:17001 
	///@remark tcpЭ飬127.0.0.1͡2001:250:250:250:250:250:250:222ַ17001˿ںš
	virtual void RegisterFront(char *pszFrontAddress) = 0;
	virtual void RegisterQryFront(char *pszFrontAddress) = 0;
	
	///עַַ
	///@param pszNsAddress ַַ
	///@remark ַĸʽΪprotocol://ipaddress:port磺IPV4: tcp://127.0.0.1:12001  IPV6: tcp://2001:250:250:250:250:250:250:222:17001 
	///@remark tcpЭ飬127.0.0.1͡2001:250:250:250:250:250:250:222ַ12001˿ںš
	///@remark RegisterNameServerRegisterFront
	///@param pszInvestorID Ͷߴ
	virtual void RegisterNameServer(char *pszNsAddress, char *pszInvestorID) = 0;
	
	///עصӿ
	///@param pSpi Իصӿʵ
	virtual void RegisterSpi(CUstpFtdcTraderSpi *pSpi) = 0;
	
	///֤
	///@param pszCertFileName û֤ļ
	///@param pszKeyFileName û˽Կļ
	///@param pszCaFileName CA֤ļ
	///@param pszKeyFilePassword û˽Կļ
	///@return 0 ɹ
	///@return -1 CA֤ʧ
	///@return -2 û֤ʧ
	///@return -3 û˽Կʧ	
	///@return -4 û֤Уʧ
	virtual int RegisterCertificateFile(const char *pszCertFileName, const char *pszKeyFileName, 
		const char *pszCaFileName, const char *pszKeyFilePassword) = 0;

	///˽
	///@param nResumeType ˽شʽ  
	///        USTP_TERT_RESTART:ӱտʼش
	///        USTP_TERT_RESUME:ϴյ
	///        USTP_TERT_QUICK:ֻ͵¼˽
	///@remark ÷ҪInitǰá򲻻յ˽ݡ
	virtual void SubscribePrivateTopic(USTP_TE_RESUME_TYPE nResumeType) = 0;
	
	///Ĺ
	///@param nResumeType شʽ  
	///        USTP_TERT_RESTART:ӱտʼش
	///        USTP_TERT_RESUME:ϴյ
	///        USTP_TERT_QUICK:ֻ͵¼󹫹
	///@remark ÷ҪInitǰá򲻻յݡ
	virtual void SubscribePublicTopic(USTP_TE_RESUME_TYPE nResumeType) = 0;

	///ĽԱ
	///@param nResumeType Աشʽ  
	///        USTP_TERT_RESTART:ӱտʼش
	///        USTP_TERT_RESUME:ϴյ
	///        USTP_TERT_QUICK:ֻ͵¼Ա
	///@remark ÷ҪInitǰá򲻻յԱݡ
	virtual void SubscribeUserTopic(USTP_TE_RESUME_TYPE nResumeType) = 0;
	///ѯ
	///@param nResumeType Աشʽ  
	///        USTP_TERT_RESTART:ӱտʼش
	///        USTP_TERT_RESUME:ϴյ
	///        USTP_TERT_QUICK:ֻ͵¼Ա
	///@remark ÷ҪInitǰá򲻻յԱݡ
	virtual void SubscribeForQuote(USTP_TE_RESUME_TYPE nResumeType) = 0;
	
	///ʱʱ䡣
	///@param timeout ʱʱ()  
	virtual void SetHeartbeatTimeout(unsigned int timeout) = 0;
	
	///־ļ
	///@param pszReqLogFileName ־ļ  
	///@return 0 ɹ
	///@return -1 ־ļʧ
	virtual int OpenRequestLog(const char *pszReqLogFileName) = 0;

	///Ӧ־ļ
	///@param pszRspLogFileName Ӧ־ļ  
	///@return 0 ɹ
	///@return -1 ־ļʧ
	virtual int OpenResponseLog(const char *pszRspLogFileName) = 0;

	///͸м̴û֤֤ 
	virtual int RegisterDSProxyUserCert(CUstpFtdcDSProxyCheckUserInfoField *pDSProxyUserUserInfo, CUstpFtdcDSProxyUserCertInField *pDSProxyUserCertIn, CUstpFtdcDSProxyUserCertOutField *pDProxyUserCertOut, int nRequestID) = 0;	
	   
	

	///ǰϵͳû¼
	virtual int ReqUserLogin(CUstpFtdcReqUserLoginField *pReqUserLogin, int nRequestID) = 0;

	///û˳
	virtual int ReqUserLogout(CUstpFtdcReqUserLogoutField *pReqUserLogout, int nRequestID) = 0;

	///û޸
	virtual int ReqUserPasswordUpdate(CUstpFtdcUserPasswordUpdateField *pUserPasswordUpdate, int nRequestID) = 0;

	///˵ȷ
	virtual int ReqSettlementInfoConfirm(CUstpFtdcInputSettlementInfoConfirmField *pInputSettlementInfoConfirm, int nRequestID) = 0;

	///Ϣȷ
	virtual int ReqMsgNotifyConfirm(CUstpFtdcInputMsgNotifyConfirmField *pInputMsgNotifyConfirm, int nRequestID) = 0;

	///¼
	virtual int ReqOrderInsert(CUstpFtdcInputOrderField *pInputOrder, int nRequestID) = 0;

	///
	virtual int ReqOrderAction(CUstpFtdcOrderActionField *pOrderAction, int nRequestID) = 0;

	///󱨼¼
	virtual int ReqQuoteInsert(CUstpFtdcInputQuoteField *pInputQuote, int nRequestID) = 0;

	///۲
	virtual int ReqQuoteAction(CUstpFtdcQuoteActionField *pQuoteAction, int nRequestID) = 0;

	///ͻѯ
	virtual int ReqForQuote(CUstpFtdcReqForQuoteField *pReqForQuote, int nRequestID) = 0;

	///ͻ
	virtual int ReqMarginCombAction(CUstpFtdcInputMarginCombActionField *pInputMarginCombAction, int nRequestID) = 0;

	///ѯ
	virtual int ReqQryOrder(CUstpFtdcQryOrderField *pQryOrder, int nRequestID) = 0;

	///ɽѯ
	virtual int ReqQryTrade(CUstpFtdcQryTradeField *pQryTrade, int nRequestID) = 0;

	///Ͷ˻ѯ
	virtual int ReqQryUserInvestor(CUstpFtdcQryUserInvestorField *pQryUserInvestor, int nRequestID) = 0;

	///ױѯ
	virtual int ReqQryTradingCode(CUstpFtdcQryTradingCodeField *pQryTradingCode, int nRequestID) = 0;

	///Ͷʽ˻ѯ
	virtual int ReqQryInvestorAccount(CUstpFtdcQryInvestorAccountField *pQryInvestorAccount, int nRequestID) = 0;

	///Լѯ
	virtual int ReqQryInstrument(CUstpFtdcQryInstrumentField *pQryInstrument, int nRequestID) = 0;

	///ѯ
	virtual int ReqQryExchange(CUstpFtdcQryExchangeField *pQryExchange, int nRequestID) = 0;

	///Ͷֲֲ߳ѯ
	virtual int ReqQryInvestorPosition(CUstpFtdcQryInvestorPositionField *pQryInvestorPosition, int nRequestID) = 0;

	///Ϲѯ
	virtual int ReqQryComplianceParam(CUstpFtdcQryComplianceParamField *pQryComplianceParam, int nRequestID) = 0;

	///Ͷʲѯ
	virtual int ReqQryInvestorFee(CUstpFtdcQryInvestorFeeField *pQryInvestorFee, int nRequestID) = 0;

	///Ͷ֤߱ʲѯ
	virtual int ReqQryInvestorMargin(CUstpFtdcQryInvestorMarginField *pQryInvestorMargin, int nRequestID) = 0;

	///ױϳֲֲѯ
	virtual int ReqQryInvestorCombPosition(CUstpFtdcQryInvestorCombPositionField *pQryInvestorCombPosition, int nRequestID) = 0;

	///ѯԼϢ
	virtual int ReqQryInstrumentGroup(CUstpFtdcQryUstpInstrumentGroupField *pQryUstpInstrumentGroup, int nRequestID) = 0;

	///ѯϱ֤
	virtual int ReqQryClientMarginCombType(CUstpFtdcQryClientMarginCombTypeField *pQryClientMarginCombType, int nRequestID) = 0;

	///Ȩ¼
	virtual int ReqExecOrderInsert(CUstpFtdcInputExecOrderField *pInputExecOrder, int nRequestID) = 0;

	///Ȩ
	virtual int ReqExecOrderAction(CUstpFtdcInputExecOrderActionField *pInputExecOrderAction, int nRequestID) = 0;

	///ѯ˵ȷ
	virtual int ReqQrySettlementInfoConfirm(CUstpFtdcInputSettlementInfoConfirmField *pInputSettlementInfoConfirm, int nRequestID) = 0;

	///ѯ
	virtual int ReqQryOrderFailed(CUstpFtdcQryOrderFailedField *pQryOrderFailed, int nRequestID) = 0;

	///ѯֲϸ
	virtual int ReqQryInvestorPositionDetail(CUstpFtdcReqQryInvestorPositionDetailField *pReqQryInvestorPositionDetail, int nRequestID) = 0;

	///ѯϳֲϸ
	virtual int ReqQryInvestorPositionCombDetail(CUstpFtdcReqQryInvestorPositionCombDetailField *pReqQryInvestorPositionCombDetail, int nRequestID) = 0;

	///ѯϵͳʱ
	virtual int ReqQrySystemTime(CUstpFtdcReqQrySystemTimeField *pReqQrySystemTime, int nRequestID) = 0;

	///ѯ֤Żݲ
	virtual int ReqQryMarginPrefParam(CUstpFtdcReqQryMarginPrefParamField *pReqQryMarginPrefParam, int nRequestID) = 0;

	///͸ܿͻ֤
	virtual int ReqDSUserCertification(CUstpFtdcDSUserInfoField *pDSUserInfo, int nRequestID) = 0;

	///͸ϢɼмϴϢ
	virtual int ReqDSProxySubmitInfo(CUstpFtdcDSProxySubmitDataField *pDSProxySubmitData, int nRequestID) = 0;

	///ѯͶ߽
	virtual int ReqQuerySettlementInfo(CUstpFtdcSettlementQryReqField *pSettlementQryReq, int nRequestID) = 0;

	///ʽ˻
	virtual int ReqTradingAccountPasswordUpdate(CUstpFtdcTradingAccountPasswordUpdateReqField *pTradingAccountPasswordUpdateReq, int nRequestID) = 0;

	///ѯתˮ
	virtual int ReqQueryTransferSeria(CUstpFtdcTransferSerialFieldReqField *pTransferSerialFieldReq, int nRequestID) = 0;

	///ѯǩԼϵ
	virtual int ReqQueryAccountRegister(CUstpFtdcAccountregisterReqField *pAccountregisterReq, int nRequestID) = 0;

	///ڻʽתڻ
	virtual int ReqFromBankToFutureByFuture(CUstpFtdcTransferFieldReqField *pTransferFieldReq, int nRequestID) = 0;

	///ڻڻʽת
	virtual int ReqFromFutureToBankByFuture(CUstpFtdcTransferFieldReqField *pTransferFieldReq, int nRequestID) = 0;

	///ڻѯ
	virtual int ReqQueryBankAccountMoneyByFuture(CUstpFtdcAccountFieldReqField *pAccountFieldReq, int nRequestID) = 0;

	///ڻ˻ǩԼ
	virtual int ReqSignUpAccountByFuture(CUstpFtdcSignUpOrCancleAccountReqFieldField *pSignUpOrCancleAccountReqField, int nRequestID) = 0;

	///ڻ˻Լ
	virtual int ReqCancleAccountByFuture(CUstpFtdcSignUpOrCancleAccountReqFieldField *pSignUpOrCancleAccountReqField, int nRequestID) = 0;

	///ѯǩԼ״̬
	virtual int ReqQuerySignUpOrCancleAccountStatus(CUstpFtdcQuerySignUpOrCancleAccountStatusReqFieldField *pQuerySignUpOrCancleAccountStatusReqField, int nRequestID) = 0;

	///ڻ˻
	virtual int ReqChangeAccountByFuture(CUstpFtdcChangeAccountReqFieldField *pChangeAccountReqField, int nRequestID) = 0;

	///ѯ󱨵
	virtual int ReqQueryMaxOrderVolume(CUstpFtdcReqQueryMaxOrderVolumeField *pReqQueryMaxOrderVolume, int nRequestID) = 0;

	///ڻѯǩԼ
	virtual int ReqQueryContractBank(CUstpFtdcQryContractBankReqField *pQryContractBankReq, int nRequestID) = 0;

	///潻ʻ
	virtual int ReqOpenSimTradeAccount(CUstpFtdcSimTradeAccountInfoField *pSimTradeAccountInfo, int nRequestID) = 0;

	///潻ʻѯ
	virtual int ReqCheckOpenSimTradeAccount(CUstpFtdcSimTradeAccountInfoField *pSimTradeAccountInfo, int nRequestID) = 0;

	///ѯ֤ϵͳ͹˾ʽ˻Կ
	virtual int ReqCFMMCTradingAccountKey(CUstpFtdcCFMMCTradingAccountKeyReqField *pCFMMCTradingAccountKeyReq, int nRequestID) = 0;

	///ֱֲ仯֪ͨ
	virtual int ReqQryEnableRtnMoneyPositoinChange(CUstpFtdcEnableRtnMoneyPositoinChangeField *pEnableRtnMoneyPositoinChange, int nRequestID) = 0;

	///ʷѯ
	virtual int ReqQueryHisOrder(CUstpFtdcQryHisOrderField *pQryHisOrder, int nRequestID) = 0;

	///ʷɽѯ
	virtual int ReqQueryHisTrade(CUstpFtdcQryHisTradeField *pQryHisTrade, int nRequestID) = 0;

	///Ѻ
	virtual int ReqCurrencyPledge(CUstpFtdcCurrencyPledgeField *pCurrencyPledge, int nRequestID) = 0;

	///м̵¼
	virtual int ReqProxyUserLogin(CUstpFtdcReqProxyUserLoginField *pReqProxyUserLogin, int nRequestID) = 0;

	///ȨԳ¼
	virtual int ReqExecSelfCloseInsert(CUstpFtdcInputExecSelfCloseField *pInputExecSelfClose, int nRequestID) = 0;

	///ȨԳó¼
	virtual int ReqExecSelfCloseAction(CUstpFtdcInputExecSelfCloseActionField *pInputExecSelfCloseAction, int nRequestID) = 0;

	///ѯֻ̼
	virtual int ReqQrySpotPrevClosePrice(CUstpFtdcQrySpotPrevClosePriceField *pQrySpotPrevClosePrice, int nRequestID) = 0;

	///Ȩ׳ɱѯ
	virtual int ReqQryOptionTradeCost(CUstpFtdcQryOptionTradeCostField *pQryOptionTradeCost, int nRequestID) = 0;

	///ϲֲѯ
	virtual int ReqQryCombAction(CUstpFtdcQryInputCombActionField *pQryInputCombAction, int nRequestID) = 0;

	///ƷϢѯ
	virtual int ReqQryProduct(CUstpFtdcQryProductField *pQryProduct, int nRequestID) = 0;

	///ȨԳòѯ
	virtual int ReqQryExecSelfClose(CUstpFtdcQryExecSelfCloseField *pQryExecSelfClose, int nRequestID) = 0;

	///볷
	virtual int ReqMarginCombCancel(CUstpFtdcAPIInputMarginCombCancelField *pAPIInputMarginCombCancel, int nRequestID) = 0;

	///л
	virtual int ReqChangeCenter(CUstpFtdcReqChangeCenterField *pReqChangeCenter, int nRequestID) = 0;

	///Ĳѯ
	virtual int ReqQryTradeCenter(CUstpFtdcQryTradeCenterField *pQryTradeCenter, int nRequestID) = 0;

	///Ԥ񵥱¼
	virtual int ReqParkedOrderInsert(CUstpFtdcParkedOrderInsertField *pParkedOrderInsert, int nRequestID) = 0;

	///Ԥ񵥳
	virtual int ReqParkedOrderAction(CUstpFtdcParkedOrderActionField *pParkedOrderAction, int nRequestID) = 0;

	///Ԥ񵥲ѯ
	virtual int ReqQryParkedOrder(CUstpFtdcQryParkedOrderField *pQryParkedOrder, int nRequestID) = 0;

	///¼
	virtual int ReqConditionalOrderInsert(CUstpFtdcConditionalOrderInsertField *pConditionalOrderInsert, int nRequestID) = 0;

	///
	virtual int ReqConditionalOrderAction(CUstpFtdcConditionalOrderActionField *pConditionalOrderAction, int nRequestID) = 0;

	///ѯ
	virtual int ReqQryConditionalOrder(CUstpFtdcQryConditionalOrderField *pQryConditionalOrder, int nRequestID) = 0;

	///ѯʷתˮ
	virtual int ReqQueryHisTransferSerial(CUstpFtdcHisTransferSerialFieldReqField *pHisTransferSerialFieldReq, int nRequestID) = 0;

	///۲ѯ
	virtual int ReqQryQuote(CUstpFtdcQryQuoteField *pQryQuote, int nRequestID) = 0;

	///Ȩѯ
	virtual int ReqQryExecOrder(CUstpFtdcQryExecOrderField *pQryExecOrder, int nRequestID) = 0;
protected:
	~CUstpFtdcTraderApi(){};
};

#endif
